%macro sasdrugdev_getfileprops(sddpath=, dsname=work._fileprops_);
  %global _sddRC_ _sddMsg_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;
  data &dsname (label="Created by sasdrugdev_getfileprops" keep=path name value);
     attrib returnCode  length=8;
     attrib message     length=$200;
     attrib rowCount    length=8;
     attrib path        length=$200 label="File Path";
     attrib name        length=$200 label="File Property Name";
     attrib value       length=$200 label="File Property Value";
    
     declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetFilePropsCommand", "%bquote(&sddpath)");
     declare javaobj results("com/sas/drugdev/remote/sasmacro/results/PropertiesResult", "file");
     cmd.callVoidMethod("execute", results);
     results.callIntMethod("getReturnCode", returnCode);
     results.callStringMethod("getReturnMessage", message);
     if (returnCode=0) then 
        do;
	     path=symget('sddpath');
             results.callIntMethod("getPropertiesCount", rowCount);
             if (rowCount=0) then 
                put "NOTE: SAS Drug Development Macro: * No properties were found.";
             else do;
                do row=0 to rowCount - 1;
                    results.callStringMethod("getPropertyName", row, name);
                    results.callStringMethod("getProperty", name, value);
                    output;
                end;
                put "NOTE: SAS Drug Development Macro: sasdrugdev_getfileprops 3.4";
                put "NOTE: SAS Drug Development Macro: * " rowCount " records written to dataset &dsname";
            end;
       end;
    else do;
      put "ERROR: SAS Drug Development Macro: sasdrugdev_getfileprops 3.4";
      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
      put "ERROR: SAS Drug Development Macro: * Tried to list file properties for %bquote(&sddpath)";
      put "ERROR: SAS Drug Development Macro: * " message;
    end;
    call symputx("_sddRC_", put(returnCode, best.));
    call symputx("_sddMsg_", message);
  run;
%mend sasdrugdev_getfileprops;
