%macro sasdrugdev_getpermissions(sddpath=, recursive=false,typeDef=*,dsname=work._getnodePermissions_);
  %global _sddRC_ _sddMsg_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;
  %let _sddRowCount_=%str(-1);
  data &dsname(label="Created by sdd_getpermissions" 
      keep=type folder isContainer fullPathName owner name sizeString ACEName canRead canWrite canDelete canManage
         canInheritRead canInheritWrite canInheritDelete canInheritManage);
    attrib returnCode     length=8;
    attrib message        length=$200;
    attrib rowCount       length=8;
    attrib type           length=$40  label="Type";
    attrib folder         length=$150  Label="SDD Folder";
    attrib isContainer    length=8     label="Is File a Container?" ;
    attrib fullPathName   length=$150  Label="SDD Full Path Name";
    attrib owner          length=$40 label="Owner";
    attrib name           length=$40  label="Display Name";
    attrib sizeString     length=$200 label="Size";
    attrib ACEName        length=$40  label="ACE Name";
    attrib canRead        length=8  label="Read Permission";
    attrib canWrite       length=8  label="Write Permission";
    attrib canDelete      length=8  label="Delete Permission";
    attrib canManage      length=8  label="Manage Permission";
    attrib canInheritRead   length=8     Label="Read Inherit Permission";
    attrib canInheritWrite  length=8     Label="Write Inherit Permission";
    attrib canInheritDelete length=8     Label="Delete Inherit Permission";
    attrib canInheritManage length=8     Label="Manage Inherit Permission";
    retain totalRowCounter 0;

    declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetNodePermissionsCommand","%bquote(&sddpath)","&recursive","&typeDef");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/GetNodesResult");
    cmd.callVoidMethod("execute", results);

    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    if (returnCode=0) then do;
      results.callIntMethod("getObjectCount", rowCount);
      do row=0 to rowCount - 1;
        results.callStringMethod("getType", row, type);
        results.callStringMethod("getFolderName", row, folder);  
        results.callLongMethod("getIsContainer", row, isContainer);
        results.callStringMethod("getPath", row, fullPathName);
        results.callStringMethod("getOwner", row, owner);
        results.callStringMethod("getName", row, name);
        results.callStringMethod("getSizeString", row, sizeString);    
    	results.callLongMethod("getAclListSize",row,aclRowCount);
	do aclRow=0 to aclRowCount-1;
           results.callStringMethod("getACLName", row,aclRow, ACEName);
           results.callBooleanMethod("getACLReadPermission", row,aclRow,canRead);
           results.callBooleanMethod("getACLWritePermission", row,aclRow,canWrite);
           results.callBooleanMethod("getACLDeletePermission", row,aclRow,canDelete);
           results.callBooleanMethod("getACLManagePermission", row,aclRow,canManage);
           results.callBooleanMethod("getACLInheritReadPermission", row,aclRow,canInheritRead);
           results.callBooleanMethod("getACLInheritWritePermission", row,aclRow,canInheritWrite);
           results.callBooleanMethod("getACLInheritDeletePermission", row,aclRow,canInheritDelete);
           results.callBooleanMethod("getACLInheritManagePermission", row,aclRow,canInheritManage);
           totalRowCounter=totalRowCounter+1;
           output;
        end;
	  end;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_getpermissions 3.4";
      put "NOTE: SAS Drug Development Macro: * returned a list of objects in %bquote(&sddpath)";
      if (rowCount=0) then
          put "NOTE: SAS Drug Development Macro: * No objects were found.";
      put "NOTE: SAS Drug Development Macro: * " totalRowCounter " records written to dataset &dsname";
    end;
    else do;
      put "ERROR: SAS Drug Development Macro: sasdrugdev_getpermissions 3.4";
      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
      put "ERROR: SAS Drug Development Macro: * Tried to list the objects in %bquote(&sddpath)";
      put "ERROR: SAS Drug Development Macro: * " message;
    end;
    call symputx("_sddRC_", returnCode);
    call symputx("_sddMsg_", message);
    call symputx("_sddObjectCount_", rowCount);
    call symputx("_sddRowCount_", totalRowCounter);
  run;
  %put returnCode=&_sddRC_;
  %put message=&_sddMsg_;
  %put objectCount=&_sddObjectCount_;
  %put rowCount=&_sddRowCount_;
%mend sasdrugdev_getpermissions;
