%macro sasdrugdev_getusergroups(sdduserid=, dsname=work._usergroups_);
%global _sddRC_ _sddMsg_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;

  data &dsname(label="Created by sasdrugdev_getusergroups" keep=userid groupname);
    attrib returnCode length=8;
    attrib message    length=$200;
    attrib rowCount   length=8;
    attrib groupname  length=$200 label="GroupName";
    attrib userid     length=$200 label="UserId";

    declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetGroupsWithUserCommand", "%bquote(&sdduserid)");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/ListResult");
    cmd.callVoidMethod("execute", results);
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    if (returnCode=0) then do;
      results.callIntMethod("getReturnedCount", rowCount);
      do row=0 to rowCount - 1;
        userid=symget('sdduserid');
        results.callStringMethod("getValue", row, "Group", groupname);
        output;
      end;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_getusergroups 3.4";
      put "NOTE: SAS Drug Development Macro: * Get groups for %bquote(&sdduserid)";
      if (rowCount=0) then 
            put "NOTE: SAS Drug Development Macro: * No groups were found.";
      put "NOTE: SAS Drug Development Macro: * " rowCount " records written to dataset %bquote(&dsname)";
    end;
    else do;
      put "ERROR: SAS Drug Development Macro: sasdrugdev_getusergroups 3.4";
      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
      put "ERROR: SAS Drug Development Macro: * Tried to get groups for %bquote(&sdduserid)";
      put "ERROR: SAS Drug Development Macro: * " message;
    end;
    call symputx("_sddRC_", returnCode);
    call symputx("_sddMsg_", message);
  run;
%mend sasdrugdev_getusergroups;
