%macro sasdrugdev_getuserpolicies(sdduserid=, dsname=work._upolicies_);
  %global _sddRC_ _sddMsg_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;

  data &dsname(label="Created by sasdrugdev_getuserpolicies" keep=userid policy action);
    attrib returnCode length=8;
    attrib message    length=$200;
    attrib rowCount   length=8;
    attrib userid     length=$200 label="UserId";
    attrib policy     length=$200 label="Policy";
	attrib  action     length=$20   label="Add/Remove";

    declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetUserPoliciesCommand", "%bquote(&sdduserid)");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/ListResult");
    cmd.callVoidMethod("execute", results);
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    if (returnCode=0) then do;
      results.callIntMethod("getReturnedCount", rowCount);
      do row=0 to rowCount - 1;
        userid=symget('sdduserid');
        results.callStringMethod("getValue", row, "Policy", policy);
		action=action;  * suppressing warning message about uninitialized variable*;
        output;
      end;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_getuserpolicies 3.4";
      put "NOTE: SAS Drug Development Macro: * Listed policies for %bquote(&sdduserid)";
      if (rowCount=0) then 
          put "NOTE: SAS Drug Development Macro: * No policies were found.";
      put "NOTE: SAS Drug Development Macro: * " rowCount " records written to dataset &dsname";
    end;
    else do;
      put "ERROR: SAS Drug Development Macro: sasdrugdev_getuserpolicies 3.4";
      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
      put "ERROR: SAS Drug Development Macro: * Tried to list policies for %bquote(&sdduserid)";
      put "ERROR: SAS Drug Development Macro: * " message;
    end;
    call symputx("_sddRC_", returnCode);
    call symputx("_sddMsg_", message);
  run;
%mend sasdrugdev_getuserpolicies;
