%macro sasdrugdev_getusers(status=ALL, dsname=work._getusers_);
  %global _sddRC_ _sddMsg_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;
  %let _sddRowCount_=%str(-1);

  data &dsname(label="Created by sasdrugdev_getusers" keep=userid firstname middlename lastname email status created lastModified);
    attrib returnCode     length=8;
    attrib message        length=$200;
    attrib rowCount       length=8;

    attrib userid          length=$200 label="UserID";
    attrib firstname      length=$200 label="First name";
    attrib middlename  length=$200 label="Middle name";
    attrib lastname       length=$200 label="Last name";
    attrib email            length=$200 label="Email";
    attrib status          length=$200 label="Status";
    attrib created         length=$200 label="Created";
    attrib lastModified  length=$200 label="Modified";     

	declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetUsersCommand", "%bquote(&status)");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/GetUsersResult");
    cmd.callVoidMethod("execute", results);
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    if (returnCode=0) then do;
      results.callIntMethod("getObjectCount", rowCount);
      do row=0 to rowCount - 1;
		    results.callStringMethod("getUserId", row, userid);
		    results.callStringMethod("getFirstName", row, firstname);
		    results.callStringMethod("getMiddleName", row, middlename);
		    results.callStringMethod("getLastName", row, lastname);
		    results.callStringMethod("getEmailAddress", row, email);
		    results.callStringMethod("getStatus", row, status);
		    results.callStringMethod("getCreatedString", row, created);
		    results.callStringMethod("getLastModifiedString", row, lastModified);
        output;
      end;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_getusers 3.4";
      put "NOTE: SAS Drug Development Macro: * returned a list of users with status %bquote(&status)";
      if (rowCount=0) then
          put "NOTE: SAS Drug Development Macro: * No users were found.";
      put "NOTE: SAS Drug Development Macro: * " rowCount " records written to dataset &dsname";
    end;
    else do;
      put "ERROR: SAS Drug Development Macro: sasdrugdev_getusers 3.4";
      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
      put "ERROR: SAS Drug Development Macro: * Tried to list the users with status %bquote(&status)";
      put "ERROR: SAS Drug Development Macro: * " message;
    end;
    call symputx("_sddRC_", returnCode);
    call symputx("_sddMsg_", message);
    call symputx("_sddRowCount_", rowCount);
  run;
  %if &_sddRowCount_ > 0 %then %do;
     proc sort data=&dsname;
       by userid;
     run;
  %end;
%mend sasdrugdev_getusers;
