%macro sasdrugdev_getuserswithpolicy(sddpolicy=, dsname=work._userswithpolicy_);
%global _sddRC_ _sddMsg_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;

  data &dsname(label="Created by sasdrugdev_getuserswithpolicy" keep=policy userid);
    attrib returnCode length=8;
    attrib message    length=$200;
    attrib rowCount   length=8;
    attrib policy     length=$200 label="Policy";
    attrib userid     length=$200 label="UserId";

    declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetUsersWithPolicyCommand", "%bquote(&sddpolicy)");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/ListResult");
    cmd.callVoidMethod("execute", results);
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    if (returnCode=0) then do;
      results.callIntMethod("getReturnedCount", rowCount);
      do row=0 to rowCount - 1;
        policy=symget('sddpolicy');
        results.callStringMethod("getValue", row, "User", userid);
        output;
      end;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_getuserswithpolicy 3.4";
      put "NOTE: SAS Drug Development Macro: * Get users with policy: %bquote(&sddpolicy)";
      if (rowCount=0) then 
          put "NOTE: SAS Drug Development Macro: * No users were found.";
      put "NOTE: SAS Drug Development Macro: * " rowCount " records written to dataset %bquote(&dsname)";
    end;
    else do;
      put "ERROR: SAS Drug Development Macro: sasdrugdev_getuserswithpolicy 3.4";
      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
      put "ERROR: SAS Drug Development Macro: * Tried to get users with policy: %bquote(&sddpolicy)";
      put "ERROR: SAS Drug Development Macro: * " message;
    end;
    call symputx("_sddRC_", returnCode);
    call symputx("_sddMsg_", message);
  run;
%mend sasdrugdev_getuserswithpolicy;
