  /* option nomprint nomprintnest nomlogic nomlogicnest nosource nosource2 nomautolocdisplay nosymbolgen; */

* this needs to be a global macro variable so the test suite can see it.  sasdrugdev_logout handle cleaning it up;

%macro sasdrugdev_login(
                 url=,          /* In form: https://sddname.sas.com/sddremote/ */
                 sdduserid=,    /* SDD userid                                  */
                 sddpassword=,  /* SDD password                                */  
                 debuglog=,     /* path to debug log file                      */     
                 debuglevel=%str(OFF) /* ALL|DEBUG|INFO|ERROR|OFF                    */
                 );       
     
  %global _sddRC_ _sddMsg_ _sddJavaLog_  _sddDebugLevel_ _sddRunningInPE_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;
        
  %let hfavail=%sysfunc(tslvl(uwuhotfi));
  %if (%sysfunc(index(&hfavail,TS)) > 0) %then
     %let _SASSPLEVEL=%sysfunc(hotfix());
  %else
     %let _SASSPLEVEL=None;
  %put SAS Hot Fix Level=&_SASSPLEVEL;

  /* Macro variable _sddusr_ is created by the PE */
  %if (%symexist(_sddusr_))%then %do;
    %let _sddRunningInPE_=%str(are);
    %end;
  %else %do;
    %let _sddRunningInPE_=%str(are not); 
    %end;
    
  %let _sddDebugLevel_=%qupcase(&debugLevel);    
  %if &_sddDebugLevel_=%str(OFF) %then %do;
    %let _sddJavaLog_=;
    %end;
  %else %do; 
    %let _sddJavaLog_=&debugLog;
    %end;
        
  data _null_;
    attrib returnCode  length=8;
    attrib message     length=$200;
    attrib version     length=$60;
    attrib logFile     length=$300;
	attrib debugLevel length=$50;
      
    declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/LoginCommand", "%bquote(&url)", "%bquote(&sdduserid)", "%bquote(&sddpassword)");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/DefaultResult");
    cmd.callStaticStringMethod("setupLogger", "&_sddJavaLog_", "&_sddDebugLevel_", logFile);
    cmd.callVoidMethod("execute", results);
	cmd.callStaticStringMethod("getLoggingLevel", debugLevel);
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    cmd.callStringMethod("getVersion", version);
    call symputx("_sddRC_",  returnCode);
    call symputx("_sddMsg_", message);
    call symputx("_sddVer_", version);
    call symputx("_sddJavaLog_", logFile);
	call symputx("_sddDebugLevel_", debugLevel);

  run;
  %put NOTE: The SAS Drug Development Macros &_sddRunningInPE_ running in the SAS Drug Development Process Editor;
  %put NOTE: SAS Drug Development Macros version=&_sddVer_;  
  %if (&_sddRC_=0 and (&syserr ^= 0 or &syserr ^= 4)) %then %do;
    %let _sddMsg_ = SAS Drug Development Macros initialized.;
    %put;
    %put NOTE: SAS Drug Development Macro: &sysmacroname 3.4;
    %put NOTE: SAS Drug Development Macro: Input Parameters:;
    %put NOTE: SAS Drug Development Macro: * url=&url;
    %put NOTE: SAS Drug Development Macro: * sdduserid=&sdduserid;            
    %put NOTE: SAS Drug Development Macro: * sddpassword=<Value not printed>;
	%put NOTE: SAS Drug Development Macro: * _sddMsg_=&_sddMsg_;
    %put NOTE: SAS Drug Development Macro: * _sddRC_=&_sddRC_;
    %put NOTE: SAS Drug Development Macro: * _sddDebugLevel_=&_sddDebugLevel_;
    %put NOTE: SAS Drug Development Macro: * _sddJavaLog_=&_sddJavaLog_;
	options nonotes;
	%sasdrugdev_getpasswordExpires()
	%put;
	options notes;
    %put;
    %end; 
  %else %do;
    %put;
    %put ERROR: SAS Drug Development Macro: &sysmacroname 3.4;
    %put ERROR: SAS Drug Development Macro: * Could not login to the SAS Drug Development Server.;
    %put ERROR: SAS Drug Development Macro: * Verify that your input parameters and configuration are correct.;
    %put ERROR: SAS Drug Development Macro: Input Parameters:;
    %put ERROR: SAS Drug Development Macro: * url=&url;
    %put ERROR: SAS Drug Development Macro: * sdduserid=&sdduserid;            
    %put ERROR: SAS Drug Development Macro: * sddpassword=<Value not printed>;
    %put ERROR: SAS Drug Development Macro: * _sddMsg_=&_sddMsg_;
    %put ERROR: SAS Drug Development Macro: * _sddRC_=&_sddRC_;
    %put ERROR: SAS Drug Development Macro: * _sddDebugLevel_=&_sddDebugLevel_;
	%put ERROR: SAS Drug Development Macro: * _sddJavaLog_=&_sddJavaLog_;
    %put;
    %end;
%mend sasdrugdev_login;
